import 'dart:html';
import 'package:rad_textures/rad_textures.dart';
import 'package:vector_math/vector_math.dart';

void main() {
  window.onLoad.listen((e) { _create(); });
}

void _plot_noise(String canvas_id, TSampler noise_callback)
{
  CanvasElement canvas = querySelector("#$canvas_id");
  CanvasRenderingContext2D ctx = canvas.getContext('2d');;
  //ctx.fillStyle = 'black';
  //ctx.fillRect(0, 0, canvas.width, canvas.height);
  ImageData imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
  double scale = 0.013;
  for(int x = 0; x < canvas.width; x++) {
    for(int y = 0; y < canvas.height; y++) {
      double sample = noise_callback(new Vector3(x * scale, y * scale, 0.0));
      imageData.data[(y * canvas.width + x) * 4 + 0] = 0;
      imageData.data[(y * canvas.width + x) * 4 + 1] = 
          FASTFLOOR((sample * 0.5 + 0.5) * 255);
      imageData.data[(y * canvas.width + x) * 4 + 2] = 0;
      imageData.data[(y * canvas.width + x) * 4 + 3] = 255;
    }
  }
  ctx.putImageData(imageData, 0, 0, 0, 0, canvas.width, canvas.height);  
}

double noise3_map(Vector3 v) { return noise3(v.x, v.y, v.z); }
double RidgedMultifractal_Default_map(Vector3 v) { return RidgedMultifractal_Default(v.x, v.y, v.z); }
double turbulence_default_map(Vector3 v) { return turbulence_default(v.x, v.y, v.z); }
double FCellNoise3_map(Vector3 v) { return FCellNoise3(v.x, v.y, v.z); }
double fBm_default_map(Vector3 v) { return fBm_default(v.x, v.y, v.z); }

void _create() {
  _plot_noise("canvas_simplex_noise", noise3_map);
  _plot_noise("canvas_ridged_multifractal", RidgedMultifractal_Default_map);
  _plot_noise("canvas_turbulence", turbulence_default_map);
  _plot_noise("canvas_cell_noise", FCellNoise3_map);
  _plot_noise("canvas_fbm", fBm_default_map);
}
